Whamcloud - gitweb
c0ee4c556636099734fc5a829a6220c5fd99f2e4
[fs/lustre-release.git] / lustre / tests / test-framework.sh
1 #!/bin/bash
2 # vim:expandtab:shiftwidth=4:softtabstop=4:tabstop=4:
3
4 trap 'print_summary && echo "test-framework exiting on error"' ERR
5 set -e
6 #set -x
7
8
9 export REFORMAT=${REFORMAT:-""}
10 export VERBOSE=false
11 export GMNALNID=${GMNALNID:-/usr/sbin/gmlndnid}
12 export CATASTROPHE=${CATASTROPHE:-/proc/sys/lnet/catastrophe}
13 export GSS=false
14 export GSS_KRB5=false
15 export GSS_PIPEFS=false
16 export IDENTITY_UPCALL=default
17 #export PDSH="pdsh -S -Rssh -w"
18
19 # eg, assert_env LUSTRE MDSNODES OSTNODES CLIENTS
20 assert_env() {
21     local failed=""
22     for name in $@; do
23         if [ -z "${!name}" ]; then
24             echo "$0: $name must be set"
25             failed=1
26         fi
27     done
28     [ $failed ] && exit 1 || true
29 }
30
31 usage() {
32     echo "usage: $0 [-r] [-f cfgfile]"
33     echo "       -r: reformat"
34
35     exit
36 }
37
38 print_summary () {
39     [ "$TESTSUITE" == "lfscktest" ] && return 0
40     [ -n "$ONLY" ] && echo "WARNING: ONLY is set to ${ONLY}."
41     local form="%-13s %-17s %s\n"
42     printf "$form" "status" "script" "skipped tests E(xcluded) S(low)"
43     echo "------------------------------------------------------------------------------------"
44     for O in $TESTSUITE_LIST; do
45         local skipped=""
46         local slow=""
47         local o=$(echo $O | tr "[:upper:]" "[:lower:]")
48         o=${o//_/-}
49         o=${o//tyn/tyN}
50         local log=${TMP}/${o}.log
51         [ -f $log ] && skipped=$(grep excluded $log | awk '{ printf " %s", $3 }' | sed 's/test_//g')
52         [ -f $log ] && slow=$(grep SLOW $log | awk '{ printf " %s", $3 }' | sed 's/test_//g')
53         [ "${!O}" = "done" ] && \
54             printf "$form" "Done" "$O" "E=$skipped" && \
55             [ -n "$slow" ] && printf "$form" "-" "-" "S=$slow"
56
57     done
58
59     for O in $TESTSUITE_LIST; do
60         [ "${!O}" = "no" ] && \
61             printf "$form" "Skipped" "$O" ""
62     done
63
64     for O in $TESTSUITE_LIST; do
65         [ "${!O}" = "done" -o "${!O}" = "no" ] || \
66             printf "$form" "UNFINISHED" "$O" ""
67     done
68 }
69
70 init_test_env() {
71     export LUSTRE=`absolute_path $LUSTRE`
72     export TESTSUITE=`basename $0 .sh`
73
74     [ -d /r ] && export ROOT=${ROOT:-/r}
75     export TMP=${TMP:-$ROOT/tmp}
76     export TESTSUITELOG=${TMP}/${TESTSUITE}.log
77     export HOSTNAME=${HOSTNAME:-`hostname`}
78
79     export PATH=:$PATH:$LUSTRE/utils:$LUSTRE/utils/gss:$LUSTRE/tests
80     export LCTL=${LCTL:-"$LUSTRE/utils/lctl"}
81     [ ! -f "$LCTL" ] && export LCTL=$(which lctl)
82     export LFS=${LFS:-"$LUSTRE/utils/lfs"}
83     [ ! -f "$LFS" ] && export LFS=$(which lfs)
84     export L_GETIDENTITY=${L_GETIDENTITY:-"$LUSTRE/utils/l_getidentity"}
85     if [ ! -f "$L_GETIDENTITY" ]; then
86         if `which l_getidentity > /dev/null 2>&1`; then
87             export L_GETIDENTITY=$(which l_getidentity)
88         else
89             export L_GETIDENTITY=NONE
90         fi
91     fi
92     export MKFS=${MKFS:-"$LUSTRE/utils/mkfs.lustre"}
93     [ ! -f "$MKFS" ] && export MKFS=$(which mkfs.lustre)
94     export TUNEFS=${TUNEFS:-"$LUSTRE/utils/tunefs.lustre"}
95     [ ! -f "$TUNEFS" ] && export TUNEFS=$(which tunefs.lustre)
96     export CHECKSTAT="${CHECKSTAT:-"checkstat -v"} "
97     export FSYTPE=${FSTYPE:-"ldiskfs"}
98     export NAME=${NAME:-local}
99     export LPROC=/proc/fs/lustre
100     export LGSSD=${LGSSD:-"$LUSTRE/utils/gss/lgssd"}
101     [ "$GSS_PIPEFS" = "true" ] && [ ! -f "$LGSSD" ] && \
102         export LGSSD=$(which lgssd)
103     export LSVCGSSD=${LSVCGSSD:-"$LUSTRE/utils/gss/lsvcgssd"}
104     [ ! -f "$LSVCGSSD" ] && export LSVCGSSD=$(which lsvcgssd)
105     export KRB5DIR=${KRB5DIR:-"/usr/kerberos"}
106     export DIR2
107     export SAVE_PWD=${SAVE_PWD:-$LUSTRE/tests}
108
109     if [ "$ACCEPTOR_PORT" ]; then
110         export PORT_OPT="--port $ACCEPTOR_PORT"
111     fi
112
113     case "x$SEC" in
114         xkrb5*)
115             echo "Using GSS/krb5 ptlrpc security flavor"
116             GSS=true
117             GSS_KRB5=true
118             ;;
119     esac
120
121     case "x$IDUP" in
122         xtrue)
123             IDENTITY_UPCALL=true
124             ;;
125         xfalse)
126             IDENTITY_UPCALL=false
127             ;;
128     esac
129
130     # Paths on remote nodes, if different
131     export RLUSTRE=${RLUSTRE:-$LUSTRE}
132     export RPWD=${RPWD:-$PWD}
133     export I_MOUNTED=${I_MOUNTED:-"no"}
134
135     # command line
136
137     while getopts "rvf:" opt $*; do
138         case $opt in
139             f) CONFIG=$OPTARG;;
140             r) REFORMAT=--reformat;;
141             v) VERBOSE=true;;
142             \?) usage;;
143         esac
144     done
145
146     shift $((OPTIND - 1))
147     ONLY=${ONLY:-$*}
148
149     [ "$TESTSUITELOG" ] && rm -f $TESTSUITELOG || true
150     rm -f $TMP/*active
151
152 }
153
154 load_module() {
155     EXT=".ko"
156     module=$1
157     shift
158     BASE=`basename $module $EXT`
159     lsmod | grep -q ${BASE} || \
160       if [ -f ${LUSTRE}/${module}${EXT} ]; then
161         insmod ${LUSTRE}/${module}${EXT} $@
162     else
163         # must be testing a "make install" or "rpm" installation
164         # note failed to load ptlrpc_gss is considered not fatal
165         if [ "$BASE" == "ptlrpc_gss" ]; then
166             modprobe $BASE $@ 2>/dev/null || echo "gss/krb5 is not supported"
167         else
168             modprobe $BASE $@
169         fi
170     fi
171 }
172
173 load_modules() {
174     if [ -n "$MODPROBE" ]; then
175         # use modprobe
176     return 0
177     fi
178     if [ "$HAVE_MODULES" = true ]; then
179     # we already loaded
180         return 0
181     fi
182     HAVE_MODULES=true
183
184     echo Loading modules from $LUSTRE
185     load_module ../lnet/libcfs/libcfs
186     [ "$PTLDEBUG" ] && lctl set_param debug=$PTLDEBUG
187     [ "$SUBSYSTEM" ] && lctl set_param subsystem_debug=${SUBSYSTEM# }
188     [ -f /etc/modprobe.conf ] && MODPROBECONF=/etc/modprobe.conf
189     [ -f /etc/modprobe.d/Lustre ] && MODPROBECONF=/etc/modprobe.d/Lustre
190     [ -z "$LNETOPTS" -a -n "$MODPROBECONF" ] && \
191         LNETOPTS=$(awk '/^options lnet/ { print $0}' $MODPROBECONF | sed 's/^options lnet //g')
192     echo "lnet options: '$LNETOPTS'"
193     # note that insmod will ignore anything in modprobe.conf
194     load_module ../lnet/lnet/lnet $LNETOPTS
195     LNETLND=${LNETLND:-"socklnd/ksocklnd"}
196     load_module ../lnet/klnds/$LNETLND
197     load_module lvfs/lvfs
198     load_module obdclass/obdclass
199     load_module ptlrpc/ptlrpc
200     load_module ptlrpc/gss/ptlrpc_gss
201     # Now, some modules depend on lquota without USE_QUOTA check,
202     # will fix later. Disable check "$USE_QUOTA" = "yes" temporary.
203     #[ "$USE_QUOTA" = "yes" ] && load_module quota/lquota
204     load_module quota/lquota
205     load_module fid/fid
206     load_module fld/fld
207     load_module lmv/lmv
208     load_module mdc/mdc
209     load_module osc/osc
210     load_module lov/lov
211     load_module mgc/mgc
212     if [ -z "$CLIENTONLY" ] && [ -z "$CLIENTMODSONLY" ]; then
213         grep -q crc16 /proc/kallsyms || { modprobe crc16 2>/dev/null || true; }
214         [ "$FSTYPE" = "ldiskfs" ] && load_module ../ldiskfs/ldiskfs/ldiskfs
215         load_module mgs/mgs
216         load_module mds/mds
217         load_module mdd/mdd
218         load_module mdt/mdt
219         load_module lvfs/fsfilt_$FSTYPE
220         load_module cmm/cmm
221         load_module osd/osd
222         load_module ost/ost
223         load_module obdfilter/obdfilter
224     fi
225
226     load_module llite/lustre
227     load_module llite/llite_lloop
228     rm -f $TMP/ogdb-$HOSTNAME
229     OGDB=$TMP
230     [ -d /r ] && OGDB="/r/tmp"
231     $LCTL modules > $OGDB/ogdb-$HOSTNAME
232
233     # 'mount' doesn't look in $PATH, just sbin
234     [ -f $LUSTRE/utils/mount.lustre ] && cp $LUSTRE/utils/mount.lustre /sbin/. || true
235 }
236
237 RMMOD=rmmod
238 if [ `uname -r | cut -c 3` -eq 4 ]; then
239     RMMOD="modprobe -r"
240 fi
241
242 wait_for_lnet() {
243     local UNLOADED=0
244     local WAIT=0
245     local MAX=60
246     MODULES=$($LCTL modules | awk '{ print $2 }')
247     while [ -n "$MODULES" ]; do
248     sleep 5
249     $RMMOD $MODULES > /dev/null 2>&1 || true
250     MODULES=$($LCTL modules | awk '{ print $2 }')
251         if [ -z "$MODULES" ]; then
252         return 0
253         else
254             WAIT=$((WAIT + 5))
255             echo "waiting, $((MAX - WAIT)) secs left"
256         fi
257         if [ $WAIT -eq $MAX ]; then
258             echo "LNET modules $MODULES will not unload"
259         lsmod
260             return 3
261         fi
262     done
263 }
264
265 unload_modules() {
266     wait_exit_ST client # bug 12845
267
268     lsmod | grep libcfs > /dev/null && $LCTL dl
269     local MODULES=$($LCTL modules | awk '{ print $2 }' | grep -v libcfs) || true
270     $RMMOD $MODULES > /dev/null 2>&1 || true
271      # do it again, in case we tried to unload ksocklnd too early
272     MODULES=$($LCTL modules | awk '{ print $2 }' | grep -v libcfs) || true
273     [ -n "$MODULES" ] && $RMMOD $MODULES > /dev/null 2>&1 || true
274     lsmod | grep libcfs > /dev/null && $LCTL dk $TMP/debug
275     $RMMOD libcfs
276     MODULES=$($LCTL modules | awk '{ print $2 }')
277     if [ -n "$MODULES" ]; then
278         echo "Modules still loaded: "
279         echo $MODULES 
280         if [ "$(lctl dl)" ]; then
281             echo "Lustre still loaded"
282             lctl dl || true
283             lsmod
284             return 2
285         else
286             echo "Lustre stopped but LNET is still loaded, waiting..."
287             wait_for_lnet || return 3
288         fi
289
290     fi
291     HAVE_MODULES=false
292
293     LEAK_LUSTRE=$(dmesg | tail -n 30 | grep "obd mem.*leaked" || true)
294     LEAK_PORTALS=$(dmesg | tail -n 20 | grep "Portals memory leaked" || true)
295     if [ "$LEAK_LUSTRE" -o "$LEAK_PORTALS" ]; then
296         echo "$LEAK_LUSTRE" 1>&2
297         echo "$LEAK_PORTALS" 1>&2
298         mv $TMP/debug $TMP/debug-leak.`date +%s` || true
299         echo "Memory leaks detected"
300         [ -n "$IGNORE_LEAK" ] && echo "ignoring leaks" && return 0
301         return 254
302     fi
303     echo "modules unloaded."
304     return 0
305 }
306
307 check_gss_daemon_facet() {
308     facet=$1
309     dname=$2
310
311     num=`do_facet $facet ps -o cmd -C $dname | grep $dname | wc -l`
312     if [ $num -ne 1 ]; then
313         echo "$num instance of $dname on $facet"
314         return 1
315     fi
316     return 0
317 }
318
319 send_sigint() {
320     local facet=$1
321     shift
322     do_facet $facet "killall -2 $@ 2>/dev/null || true"
323 }
324
325 start_gss_daemons() {
326     # starting on MDT
327     for num in `seq $MDSCOUNT`; do
328         do_facet mds$num "$LSVCGSSD -v"
329         if $GSS_PIPEFS; then
330             do_facet mds$num "$LGSSD -v"
331         fi
332     done
333     # starting on OSTs
334     for num in `seq $OSTCOUNT`; do
335         do_facet ost$num "$LSVCGSSD -v"
336     done
337     # starting on client
338     # FIXME: is "client" the right facet name?
339     if $GSS_PIPEFS; then
340         do_facet client "$LGSSD -v"
341     fi
342
343     # wait daemons entering "stable" status
344     sleep 5
345
346     #
347     # check daemons are running
348     #
349     for num in `seq $MDSCOUNT`; do
350         check_gss_daemon_facet mds$num lsvcgssd
351         if $GSS_PIPEFS; then
352             check_gss_daemon_facet mds$num lgssd
353         fi
354     done
355     for num in `seq $OSTCOUNT`; do
356         check_gss_daemon_facet ost$num lsvcgssd
357     done
358     if $GSS_PIPEFS; then
359         check_gss_daemon_facet client lgssd
360     fi
361 }
362
363 stop_gss_daemons() {
364     for num in `seq $MDSCOUNT`; do
365         send_sigint mds$num lsvcgssd lgssd
366     done
367     for num in `seq $OSTCOUNT`; do
368         send_sigint ost$num lsvcgssd
369     done
370     send_sigint client lgssd
371 }
372
373 init_gss() {
374     if $GSS; then
375         start_gss_daemons
376     fi
377 }
378
379 cleanup_gss() {
380     if $GSS; then
381         stop_gss_daemons
382         # maybe cleanup credential cache?
383     fi
384 }
385
386 mdsdevlabel() {
387     local num=$1
388     local device=`mdsdevname $num`
389     local label=`do_facet mds$num "e2label ${device}" | grep -v "CMD: "`
390     echo -n $label
391 }
392
393 ostdevlabel() {
394     local num=$1
395     local device=`ostdevname $num`
396     local label=`do_facet ost$num "e2label ${device}" | grep -v "CMD: "`
397     echo -n $label
398 }
399
400 # Facet functions
401 mount_facet() {
402     local facet=$1
403     shift
404     local dev=${facet}_dev
405     local opt=${facet}_opt
406     echo "Starting ${facet}: ${!opt} $@ ${!dev} ${MOUNT%/*}/${facet}"
407     do_facet ${facet} mount -t lustre ${!opt} $@ ${!dev} ${MOUNT%/*}/${facet}     
408     RC=${PIPESTATUS[0]}
409     if [ $RC -ne 0 ]; then
410         echo "mount -t lustre $@ ${device} ${MOUNT%/*}/${facet}"
411         echo "Start of ${device} on ${facet} failed ${RC}"
412     else
413         do_facet ${facet} "lctl set_param debug=$PTLDEBUG; \
414             lctl set_param subsystem_debug=${SUBSYSTEM# }; \
415             lctl set_param debug_mb=${DEBUG_SIZE}; \
416             sync"
417     fi
418     return $RC
419 }
420
421 # start facet device options
422 start() {
423     facet=$1
424     shift
425     device=$1
426     shift
427     eval export ${facet}_dev=${device}
428     eval export ${facet}_opt=\"$@\"
429     do_facet ${facet} mkdir -p ${MOUNT%/*}/${facet}
430     mount_facet ${facet}
431     RC=$?
432     if [ $RC -eq 0 ]; then
433         label=$(do_facet ${facet} "e2label ${device}")
434         [ -z "$label" ] && echo no label for ${device} && exit 1
435         eval export ${facet}_svc=${label}
436         echo Started ${label}
437     fi
438     return $RC
439 }
440
441 stop() {
442     local running
443     facet=$1
444     shift
445     HOST=`facet_active_host $facet`
446     [ -z $HOST ] && echo stop: no host for $facet && return 0
447
448     running=$(do_facet ${facet} "grep -c ${MOUNT%/*}/${facet}' ' /proc/mounts") || true
449     if [ ${running} -ne 0 ]; then
450         echo "Stopping ${MOUNT%/*}/${facet} (opts:$@)"
451         do_facet ${facet} umount -d $@ ${MOUNT%/*}/${facet}
452     fi
453
454     # umount should block, but we should wait for unrelated obd's
455     # like the MGS or MGC to also stop.
456     wait_exit_ST ${facet}
457 }
458
459 zconf_mount() {
460     local OPTIONS
461     local client=$1
462     local mnt=$2
463     # Only supply -o to mount if we have options
464     if [ -n "$MOUNTOPT" ]; then
465         OPTIONS="-o $MOUNTOPT"
466     fi
467     local device=$MGSNID:/$FSNAME
468     if [ -z "$mnt" -o -z "$FSNAME" ]; then
469         echo Bad zconf mount command: opt=$OPTIONS dev=$device mnt=$mnt
470         exit 1
471     fi
472
473     echo "Starting client: $client: $OPTIONS $device $mnt"
474     do_node $client mkdir -p $mnt
475     do_node $client mount -t lustre $OPTIONS $device $mnt || return 1
476
477     do_node $client "lctl set_param debug=$PTLDEBUG;
478         lctl set_param subsystem_debug=${SUBSYSTEM# };
479         lctl set_param debug_mb=${DEBUG_SIZE}"
480     [ -d /r ] && $LCTL modules > /r/tmp/ogdb-$HOSTNAME
481     return 0
482 }
483
484 zconf_umount() {
485     local client=$1
486     local mnt=$2
487     [ "$3" ] && force=-f
488     local running=$(do_node $client "grep -c $mnt' ' /proc/mounts") || true
489     if [ $running -ne 0 ]; then
490         echo "Stopping client $client $mnt (opts:$force)"
491         lsof | grep "$mnt" || true
492         do_node $client umount $force $mnt
493     fi
494 }
495
496 zconf_mount_clients() {
497     local OPTIONS
498     local clients=$1
499     local mnt=$2
500
501
502     # Only supply -o to mount if we have options
503     if [ -n "$MOUNTOPT" ]; then
504         OPTIONS="-o $MOUNTOPT"
505     fi
506     local device=$MGSNID:/$FSNAME
507     if [ -z "$mnt" -o -z "$FSNAME" ]; then
508         echo Bad zconf mount command: opt=$OPTIONS dev=$device mnt=$mnt
509         exit 1
510     fi
511
512     echo "Starting client $clients: $OPTIONS $device $mnt"
513     do_nodes $clients mkdir -p $mnt
514     do_nodes $clients mount -t lustre $OPTIONS $device $mnt || return 1
515
516     do_nodes $clients "sysctl -w lnet.debug=$PTLDEBUG;
517         sysctl -w lnet.subsystem_debug=${SUBSYSTEM# };
518         sysctl -w lnet.debug_mb=${DEBUG_SIZE};"
519
520     return 0
521 }
522
523 zconf_umount_clients() {
524     local clients=$1
525     local mnt=$2
526     [ "$3" ] && force=-f
527
528     echo "Umounting clients: $clients"
529     echo "Stopping client $client $mnt (opts:$force)"
530     do_nodes $clients umount $force $mnt 
531 }
532
533 shutdown_facet() {
534     facet=$1
535     if [ "$FAILURE_MODE" = HARD ]; then
536         $POWER_DOWN `facet_active_host $facet`
537         sleep 2
538     elif [ "$FAILURE_MODE" = SOFT ]; then
539         stop $facet
540     fi
541 }
542
543 reboot_facet() {
544     facet=$1
545     if [ "$FAILURE_MODE" = HARD ]; then
546         $POWER_UP `facet_active_host $facet`
547     else
548         sleep 10
549     fi
550 }
551
552 # verify that lustre actually cleaned up properly
553 cleanup_check() {
554     [ -f $CATASTROPHE ] && [ `cat $CATASTROPHE` -ne 0 ] && \
555         error "LBUG/LASSERT detected"
556     BUSY=`dmesg | grep -i destruct || true`
557     if [ "$BUSY" ]; then
558         echo "$BUSY" 1>&2
559         [ -e $TMP/debug ] && mv $TMP/debug $TMP/debug-busy.`date +%s`
560         exit 205
561     fi
562     LEAK_LUSTRE=`dmesg | tail -n 30 | grep "obd mem.*leaked" || true`
563     LEAK_PORTALS=`dmesg | tail -n 20 | grep "Portals memory leaked" || true`
564     if [ "$LEAK_LUSTRE" -o "$LEAK_PORTALS" ]; then
565         echo "$0: $LEAK_LUSTRE" 1>&2
566         echo "$0: $LEAK_PORTALS" 1>&2
567         echo "$0: Memory leak(s) detected..." 1>&2
568         mv $TMP/debug $TMP/debug-leak.`date +%s`
569         exit 204
570     fi
571
572     [ "`lctl dl 2> /dev/null | wc -l`" -gt 0 ] && lctl dl && \
573         echo "$0: lustre didn't clean up..." 1>&2 && return 202 || true
574
575     if [ "`/sbin/lsmod 2>&1 | egrep 'lnet|libcfs'`" ]; then
576         echo "$0: modules still loaded..." 1>&2
577         /sbin/lsmod 1>&2
578         return 203
579     fi
580     return 0
581 }
582
583 wait_delete_completed () {
584     local TOTALPREV=`awk 'BEGIN{total=0}; {total+=$1}; END{print total}' \
585             $LPROC/osc/*/kbytesavail`
586
587     local WAIT=0
588     local MAX_WAIT=20
589     while [ "$WAIT" -ne "$MAX_WAIT" ]; do
590         sleep 1
591         TOTAL=`awk 'BEGIN{total=0}; {total+=$1}; END{print total}' \
592             $LPROC/osc/*/kbytesavail`
593         [ "$TOTAL" -eq "$TOTALPREV" ] && break
594         echo "Waiting delete completed ... prev: $TOTALPREV current: $TOTAL "
595         TOTALPREV=$TOTAL
596         WAIT=$(( WAIT + 1))
597     done
598     echo "Delete completed."
599 }
600
601 wait_for_host() {
602     HOST=$1
603     check_network "$HOST" 900
604     while ! do_node $HOST "ls -d $LUSTRE " > /dev/null; do sleep 5; done
605 }
606
607 wait_for() {
608     facet=$1
609     HOST=`facet_active_host $facet`
610     wait_for_host $HOST
611 }
612
613 wait_mds_recovery_done () {
614     local timeout=`do_facet mds lctl get_param  -n timeout`
615 #define OBD_RECOVERY_TIMEOUT (obd_timeout * 5 / 2)
616 # as we are in process of changing obd_timeout in different ways
617 # let's set MAX longer than that
618     MAX=$(( timeout * 4 ))
619     WAIT=0
620     while [ $WAIT -lt $MAX ]; do
621         STATUS=`do_facet $SINGLEMDS grep status /proc/fs/lustre/mdt/*-MDT*/recovery_status`
622         echo $STATUS | grep COMPLETE && return 0
623         sleep 5
624         WAIT=$((WAIT + 5))
625         echo "Waiting $(($MAX - $WAIT)) secs for MDS recovery done"
626     done
627     echo "MDS recovery not done in $MAX sec"
628     return 1
629 }
630
631 wait_exit_ST () {
632     local facet=$1
633
634     local WAIT=0
635     local INTERVAL=1
636     # conf-sanity 31 takes a long time cleanup
637     while [ $WAIT -lt 300 ]; do
638         running=$(do_facet ${facet} "lsmod | grep lnet > /dev/null && lctl dl | grep ' ST '") || true
639         [ -z "${running}" ] && return 0
640         echo "waited $WAIT for${running}"
641         [ $INTERVAL -lt 64 ] && INTERVAL=$((INTERVAL + INTERVAL))
642         sleep $INTERVAL
643         WAIT=$((WAIT + INTERVAL))
644     done
645     echo "service didn't stop after $WAIT seconds.  Still running:"
646     echo ${running}
647     return 1
648 }
649
650 client_df() {
651     # not every config has many clients
652     if [ ! -z "$CLIENTS" ]; then
653         $PDSH $CLIENTS "df $MOUNT" > /dev/null
654     else
655         df $MOUNT > /dev/null
656     fi
657 }
658
659 client_reconnect() {
660     uname -n >> $MOUNT/recon
661     if [ ! -z "$CLIENTS" ]; then
662         $PDSH $CLIENTS "df $MOUNT; uname -n >> $MOUNT/recon" > /dev/null
663     fi
664     echo Connected clients:
665     cat $MOUNT/recon
666     ls -l $MOUNT/recon > /dev/null
667     rm $MOUNT/recon
668 }
669
670 facet_failover() {
671     facet=$1
672     echo "Failing $facet on node `facet_active_host $facet`"
673     shutdown_facet $facet
674     reboot_facet $facet
675     client_df &
676     DFPID=$!
677     echo "df pid is $DFPID"
678     change_active $facet
679     TO=`facet_active_host $facet`
680     echo "Failover $facet to $TO"
681     wait_for $facet
682     mount_facet $facet || error "Restart of $facet failed"
683 }
684
685 obd_name() {
686     local facet=$1
687 }
688
689 replay_barrier() {
690     local facet=$1
691     do_facet $facet sync
692     df $MOUNT
693     local svc=${facet}_svc
694     do_facet $facet $LCTL --device %${!svc} readonly
695     do_facet $facet $LCTL --device %${!svc} notransno
696     do_facet $facet $LCTL mark "$facet REPLAY BARRIER on ${!svc}"
697     $LCTL mark "local REPLAY BARRIER on ${!svc}"
698 }
699
700 replay_barrier_nodf() {
701     local facet=$1    echo running=${running}
702     do_facet $facet sync
703     local svc=${facet}_svc
704     echo Replay barrier on ${!svc}
705     do_facet $facet $LCTL --device %${!svc} readonly
706     do_facet $facet $LCTL --device %${!svc} notransno
707     do_facet $facet $LCTL mark "$facet REPLAY BARRIER on ${!svc}"
708     $LCTL mark "local REPLAY BARRIER on ${!svc}"
709 }
710
711 mds_evict_client() {
712     UUID=`cat /proc/fs/lustre/mdc/${mds1_svc}-mdc-*/uuid`
713     do_facet mds1 "echo $UUID > /proc/fs/lustre/mdt/${mds1_svc}/evict_client"
714 }
715
716 ost_evict_client() {
717     UUID=`grep ${ost1_svc}-osc- $LPROC/devices | egrep -v 'MDT' | awk '{print $5}'`
718     do_facet ost1 "echo $UUID > /proc/fs/lustre/obdfilter/${ost1_svc}/evict_client"
719 }
720
721 fail() {
722     facet_failover $* || error "failover: $?"
723     df $MOUNT || error "post-failover df: $?"
724 }
725
726 fail_nodf() {
727         local facet=$1
728         facet_failover $facet
729 }
730
731 fail_abort() {
732     local facet=$1
733     stop $facet
734     change_active $facet
735     mount_facet $facet -o abort_recovery
736     df $MOUNT || echo "first df failed: $?"
737     sleep 1
738     df $MOUNT || error "post-failover df: $?"
739 }
740
741 do_lmc() {
742     echo There is no lmc.  This is mountconf, baby.
743     exit 1
744 }
745
746 h2gm () {
747     if [ "$1" = "client" -o "$1" = "'*'" ]; then echo \'*\'; else
748         ID=`$PDSH $1 $GMNALNID -l | cut -d\  -f2`
749         echo $ID"@gm"
750     fi
751 }
752
753 h2name_or_ip() {
754     if [ "$1" = "client" -o "$1" = "'*'" ]; then echo \'*\'; else
755         echo $1"@$2"
756     fi
757 }
758
759 h2ptl() {
760    if [ "$1" = "client" -o "$1" = "'*'" ]; then echo \'*\'; else
761        ID=`xtprocadmin -n $1 2>/dev/null | egrep -v 'NID' | awk '{print $1}'`
762        if [ -z "$ID" ]; then
763            echo "Could not get a ptl id for $1..."
764            exit 1
765        fi
766        echo $ID"@ptl"
767    fi
768 }
769 declare -fx h2ptl
770
771 h2tcp() {
772     h2name_or_ip "$1" "tcp"
773 }
774 declare -fx h2tcp
775
776 h2elan() {
777     if [ "$1" = "client" -o "$1" = "'*'" ]; then echo \'*\'; else
778         if type __h2elan >/dev/null 2>&1; then
779             ID=$(__h2elan $1)
780         else
781             ID=`echo $1 | sed 's/[^0-9]*//g'`
782         fi
783         echo $ID"@elan"
784     fi
785 }
786 declare -fx h2elan
787
788 h2openib() {
789     h2name_or_ip "$1" "openib"
790 }
791 declare -fx h2openib
792
793 h2o2ib() {
794     h2name_or_ip "$1" "o2ib"
795 }
796 declare -fx h2o2ib
797
798 facet_host() {
799     local facet=$1
800     varname=${facet}_HOST
801     if [ -z "${!varname}" ]; then
802         if [ "${facet:0:3}" == "ost" ]; then
803             eval ${facet}_HOST=${ost_HOST}
804         fi
805     fi
806     echo -n ${!varname}
807 }
808
809 facet_active() {
810     local facet=$1
811     local activevar=${facet}active
812
813     if [ -f $TMP/${facet}active ] ; then
814         source $TMP/${facet}active
815     fi
816
817     active=${!activevar}
818     if [ -z "$active" ] ; then
819         echo -n ${facet}
820     else
821         echo -n ${active}
822     fi
823 }
824
825 facet_active_host() {
826     local facet=$1
827     local active=`facet_active $facet`
828     if [ "$facet" == client ]; then
829         echo $HOSTNAME
830     else
831         echo `facet_host $active`
832     fi
833 }
834
835 change_active() {
836     local facet=$1
837     failover=${facet}failover
838     host=`facet_host $failover`
839     [ -z "$host" ] && return
840     curactive=`facet_active $facet`
841     if [ -z "${curactive}" -o "$curactive" == "$failover" ] ; then
842         eval export ${facet}active=$facet
843     else
844         eval export ${facet}active=$failover
845     fi
846     # save the active host for this facet
847     activevar=${facet}active
848     echo "$activevar=${!activevar}" > $TMP/$activevar
849 }
850
851 do_node() {
852     HOST=$1
853     shift
854     local myPDSH=$PDSH
855     if [ "$HOST" = "$HOSTNAME" ]; then
856         myPDSH="no_dsh"
857     elif [ -z "$myPDSH" -o "$myPDSH" = "no_dsh" ]; then
858         echo "cannot run remote command on $HOST with $myPDSH"
859         return 128
860     fi
861     if $VERBOSE; then
862         echo "CMD: $HOST $@" >&2
863         $myPDSH $HOST $LCTL mark "$@" > /dev/null 2>&1 || :
864     fi
865
866     if [ "$myPDSH" = "rsh" ]; then
867 # we need this because rsh does not return exit code of an executed command
868         local command_status="$TMP/cs"
869         rsh $HOST ":> $command_status"
870         rsh $HOST "(PATH=\$PATH:$RLUSTRE/utils:$RLUSTRE/tests:/sbin:/usr/sbin;
871                     cd $RPWD; sh -c \"$@\") || 
872                     echo command failed >$command_status"
873         [ -n "$($myPDSH $HOST cat $command_status)" ] && return 1 || true
874         return 0
875     fi
876     $myPDSH $HOST "(PATH=\$PATH:$RLUSTRE/utils:$RLUSTRE/tests:/sbin:/usr/sbin; cd $RPWD; sh -c \"$@\")" | sed "s/^${HOST}: //"
877     return ${PIPESTATUS[0]}
878 }
879
880 do_nodes() {
881     local nodes=$1
882     shift
883
884     nodes=${nodes//,/ }
885     # split list to local and remote
886     local rnodes=$(echo " $nodes " | sed -re "s/\s+$HOSTNAME\s+/ /g")
887  
888     if [ "$(get_node_count $nodes)" != "$(get_node_count $rnodes)" ]; then
889         do_node $HOSTNAME $@
890     fi
891
892     [ -z "$(echo $rnodes)" ] && return 0
893
894     # This is part from do_node
895     local myPDSH=$PDSH
896
897     rnodes=$(comma_list $rnodes)
898     [ -z "$myPDSH" -o "$myPDSH" = "no_dsh" ] && \
899         echo "cannot run remote command on $rnodes with $myPDSH" && return 128
900
901     if $VERBOSE; then
902         echo "CMD: $rnodes $@" >&2
903         $myPDSH $rnodes $LCTL mark "$@" > /dev/null 2>&1 || :
904     fi
905
906     if [ "$myPDSH" = "rsh" ]; then
907 # we need this because rsh does not return exit code of an executed command
908         local command_status="$TMP/cs"
909         rsh $rnodes ":> $command_status"
910         rsh $rnodes "(PATH=\$PATH:$RLUSTRE/utils:$RLUSTRE/tests:/sbin:/usr/sbin;
911                     cd $RPWD; sh -c \"$@\") || 
912                     echo command failed >$command_status"
913         [ -n "$($myPDSH $rnodes cat $command_status)" ] && return 1 || true
914         return 0
915     fi
916     $myPDSH $rnodes "(PATH=\$PATH:$RLUSTRE/utils:$RLUSTRE/tests:/sbin:/usr/sbin; cd $RPWD; sh -c \"$@\")" | sed -re "s/\w+:\s//g"
917     return ${PIPESTATUS[0]}
918 }
919
920
921 do_facet() {
922     facet=$1
923     shift
924     HOST=`facet_active_host $facet`
925     [ -z $HOST ] && echo No host defined for facet ${facet} && exit 1
926     do_node $HOST "$@"
927 }
928
929 add() {
930     local facet=$1
931     shift
932     # make sure its not already running
933     stop ${facet} -f
934     rm -f $TMP/${facet}active
935     do_facet ${facet} $MKFS $*
936 }
937
938 ostdevname() {
939     num=$1
940     DEVNAME=OSTDEV$num
941     #if $OSTDEVn isn't defined, default is $OSTDEVBASE + num
942     eval DEVPTR=${!DEVNAME:=${OSTDEVBASE}${num}}
943     echo -n $DEVPTR
944 }
945
946 mdsdevname() {
947     num=$1
948     DEVNAME=MDSDEV$num
949     #if $MDSDEVn isn't defined, default is $MDSDEVBASE + num
950     eval DEVPTR=${!DEVNAME:=${MDSDEVBASE}${num}}
951     echo -n $DEVPTR
952 }
953
954 ########
955 ## MountConf setup
956
957 stopall() {
958     # make sure we are using the primary server, so test-framework will
959     # be able to clean up properly.
960     activemds=`facet_active mds1`
961     if [ $activemds != "mds1" ]; then
962         fail mds1
963     fi
964
965     # assume client mount is local
966     grep " $MOUNT " /proc/mounts && zconf_umount $HOSTNAME $MOUNT $*
967     grep " $MOUNT2 " /proc/mounts && zconf_umount $HOSTNAME $MOUNT2 $*
968
969     if [ -n "$CLIENTS" ]; then
970             zconf_umount_clients $CLIENTS $MOUNT "$*" || true
971             zconf_umount_clients $CLIENTS $MOUNT2 "$*" || true
972     fi
973
974     [ "$CLIENTONLY" ] && return
975     # The add fn does rm ${facet}active file, this would be enough
976     # if we use do_facet <facet> only after the facet added, but
977     # currently we use do_facet mds in local.sh
978     for num in `seq $MDSCOUNT`; do
979         stop mds$num -f
980         rm -f ${TMP}/mds${num}active
981     done
982
983     for num in `seq $OSTCOUNT`; do
984         stop ost$num -f
985         rm -f $TMP/ost${num}active
986     done
987
988     return 0
989 }
990
991 cleanupall() {
992     stopall $*
993     unload_modules
994     cleanup_gss
995 }
996
997 mdsmkfsopts()
998 {
999     local nr=$1
1000     test $nr = 1 && echo -n $MDS_MKFS_OPTS || echo -n $MDSn_MKFS_OPTS
1001 }
1002
1003 formatall() {
1004     [ "$FSTYPE" ] && FSTYPE_OPT="--backfstype $FSTYPE"
1005
1006     if [ ! -z $SEC ]; then
1007         MDS_MKFS_OPTS="$MDS_MKFS_OPTS --param srpc.flavor.default=$SEC"
1008         OST_MKFS_OPTS="$OST_MKFS_OPTS --param srpc.flavor.default=$SEC"
1009     fi
1010
1011     stopall
1012     # We need ldiskfs here, may as well load them all
1013     load_modules
1014     [ "$CLIENTONLY" ] && return
1015     echo "Formatting mdts, osts"
1016     for num in `seq $MDSCOUNT`; do
1017         echo "Format mds$num: $(mdsdevname $num)"
1018         if $VERBOSE; then
1019             add mds$num `mdsmkfsopts $num` $FSTYPE_OPT --reformat `mdsdevname $num` || exit 9
1020         else
1021             add mds$num `mdsmkfsopts $num` $FSTYPE_OPT --reformat `mdsdevname $num` > /dev/null || exit 9
1022         fi
1023     done
1024
1025     for num in `seq $OSTCOUNT`; do
1026         echo "Format ost$num: $(ostdevname $num)"
1027         if $VERBOSE; then
1028             add ost$num $OST_MKFS_OPTS --reformat `ostdevname $num` || exit 10
1029         else
1030             add ost$num $OST_MKFS_OPTS --reformat `ostdevname $num` > /dev/null || exit 10
1031         fi
1032     done
1033 }
1034
1035 mount_client() {
1036     grep " $1 " /proc/mounts || zconf_mount $HOSTNAME $*
1037 }
1038
1039 umount_client() {
1040     grep " $1 " /proc/mounts && zconf_umount `hostname` $*
1041 }
1042
1043 # return value:
1044 # 0: success, the old identity set already.
1045 # 1: success, the old identity does not set.
1046 # 2: fail.
1047 switch_identity() {
1048     local num=$1
1049     local switch=$2
1050     local j=`expr $num - 1`
1051     local MDT="`do_facet mds$num find $LPROC/mdt/ -name \*MDT\*$j -printf %f 2>/dev/null || true`"
1052
1053     if [ -z "$MDT" ]; then
1054         return 2
1055     fi
1056
1057     local old="`do_facet mds$num cat $LPROC/mdt/$MDT/identity_upcall`"
1058
1059     if $switch; then
1060         do_facet mds$num "echo \"$L_GETIDENTITY\" > $LPROC/mdt/$MDT/identity_upcall"
1061     else
1062         do_facet mds$num "echo \"NONE\" > $LPROC/mdt/$MDT/identity_upcall"
1063     fi
1064
1065     do_facet mds$num "echo \"-1\" > $LPROC/mdt/$MDT/identity_flush"
1066
1067     if [ $old = "NONE" ]; then
1068         return 1
1069     else
1070         return 0
1071     fi
1072 }
1073
1074 remount_client()
1075 {
1076         zconf_umount `hostname` $1 || error "umount failed"
1077         zconf_mount `hostname` $1 || error "mount failed"
1078 }
1079
1080 set_obd_timeout() {
1081     local facet=$1
1082     local timeout=$2
1083
1084     do_facet $facet lsmod | grep -q obdclass || \
1085         do_facet $facet "modprobe obdclass"
1086
1087     do_facet $facet "lctl set_param timeout=$timeout"
1088 }
1089
1090 setupall() {
1091     load_modules
1092     init_gss
1093     if [ -z "$CLIENTONLY" ]; then
1094         echo "Setup mdts, osts"
1095         for num in `seq $MDSCOUNT`; do
1096             DEVNAME=$(mdsdevname $num)
1097             echo $REFORMAT | grep -q "reformat" \
1098             || do_facet mds$num "$TUNEFS --writeconf $DEVNAME"
1099             set_obd_timeout mds$num $TIMEOUT
1100             start mds$num $DEVNAME $MDS_MOUNT_OPTS
1101
1102             # We started mds, now we should set failover variables properly.
1103             # Set mds${num}failover_HOST if it is not set (the default failnode).
1104             if [ -z "$mds${num}failover_HOST" ]; then
1105                 mds${num}failover_HOST=$(facet_host mds$num)
1106             fi
1107
1108             if [ $IDENTITY_UPCALL != "default" ]; then
1109                 switch_identity $num $IDENTITY_UPCALL
1110             fi
1111         done
1112         for num in `seq $OSTCOUNT`; do
1113             DEVNAME=$(ostdevname $num)
1114             set_obd_timeout ost$num $TIMEOUT
1115             start ost$num $DEVNAME $OST_MOUNT_OPTS
1116
1117             # We started ost$num, now we should set ost${num}failover variable properly.
1118             # Set ost${num}failover_HOST if it is not set (the default failnode).
1119             varname=ost${num}failover_HOST
1120             if [ -z "${!varname}" ]; then
1121                 eval ost${num}failover_HOST=$(facet_host ost${num})
1122             fi
1123
1124         done
1125     fi
1126     [ "$DAEMONFILE" ] && $LCTL debug_daemon start $DAEMONFILE $DAEMONSIZE
1127     mount_client $MOUNT
1128     [ -n "$CLIENTS" ] && zconf_mount_clients $CLIENTS $MOUNT
1129
1130     if [ "$MOUNT_2" ]; then
1131         mount_client $MOUNT2
1132         [ -n "$CLIENTS" ] && zconf_mount_clients $CLIENTS $MOUNT2
1133     fi
1134
1135     # by remounting mdt before ost, initial connect from mdt to ost might
1136     # timeout because ost is not ready yet. wait some time to its fully
1137     # recovery. initial obd_connect timeout is 5s; in GSS case it's preceeded
1138     # by a context negotiation rpc with $TIMEOUT.
1139     # FIXME better by monitoring import status.
1140     if $GSS; then
1141         sleep $((TIMEOUT + 5))
1142     else
1143         sleep 5
1144     fi
1145 }
1146
1147 mounted_lustre_filesystems() {
1148         awk '($3 ~ "lustre" && $1 ~ ":") { print $2 }' /proc/mounts
1149 }
1150
1151 check_and_setup_lustre() {
1152     MOUNTED="`mounted_lustre_filesystems`"
1153     if [ -z "$MOUNTED" ]; then
1154         [ "$REFORMAT" ] && formatall
1155         setupall
1156         MOUNTED="`mounted_lustre_filesystems`"
1157         [ -z "$MOUNTED" ] && error "NAME=$NAME not mounted"
1158         export I_MOUNTED=yes
1159     fi
1160     if [ "$ONLY" == "setup" ]; then
1161         exit 0
1162     fi
1163 }
1164
1165 cleanup_and_setup_lustre() {
1166     if [ "$ONLY" == "cleanup" -o "`mount | grep $MOUNT`" ]; then
1167         lctl set_param debug=0 || true
1168         cleanupall
1169         if [ "$ONLY" == "cleanup" ]; then
1170             exit 0
1171         fi
1172     fi
1173     check_and_setup_lustre
1174 }
1175
1176 check_and_cleanup_lustre() {
1177     if [ "`mount | grep $MOUNT`" ]; then
1178         [ -n "$DIR" ] && rm -rf $DIR/[Rdfs][0-9]*
1179     fi
1180     if [ "$I_MOUNTED" = "yes" ]; then
1181         cleanupall -f || error "cleanup failed"
1182     fi
1183     unset I_MOUNTED
1184 }
1185
1186 #######
1187 # General functions
1188
1189 check_network() {
1190     local NETWORK=0
1191     local WAIT=0
1192     local MAX=$2
1193     while [ $NETWORK -eq 0 ]; do
1194         ping -c 1 -w 3 $1 > /dev/null
1195         if [ $? -eq 0 ]; then
1196             NETWORK=1
1197         else
1198             WAIT=$((WAIT + 5))
1199             echo "waiting for $1, $((MAX - WAIT)) secs left"
1200             sleep 5
1201         fi
1202         if [ $WAIT -gt $MAX ]; then
1203             echo "Network not available"
1204             exit 1
1205         fi
1206     done
1207 }
1208 check_port() {
1209     while( !($DSH2 $1 "netstat -tna | grep -q $2") ) ; do
1210         sleep 9
1211     done
1212 }
1213
1214 no_dsh() {
1215     shift
1216     eval $@
1217 }
1218
1219 comma_list() {
1220     # the sed converts spaces to commas, but leaves the last space
1221     # alone, so the line doesn't end with a comma.
1222     echo "$*" | tr -s " " "\n" | sort -b -u | tr "\n" " " | sed 's/ \([^$]\)/,\1/g'
1223 }
1224
1225 absolute_path() {
1226     (cd `dirname $1`; echo $PWD/`basename $1`)
1227 }
1228
1229 ##################################
1230 # OBD_FAIL funcs
1231
1232 drop_request() {
1233 # OBD_FAIL_MDS_ALL_REQUEST_NET
1234     RC=0
1235     do_facet mds lctl set_param fail_loc=0x123
1236     do_facet client "$1" || RC=$?
1237     do_facet mds lctl set_param fail_loc=0
1238     return $RC
1239 }
1240
1241 drop_reply() {
1242 # OBD_FAIL_MDS_ALL_REPLY_NET
1243     RC=0
1244     do_facet mds lctl set_param fail_loc=0x122
1245     do_facet client "$@" || RC=$?
1246     do_facet mds lctl set_param fail_loc=0
1247     return $RC
1248 }
1249
1250 drop_reint_reply() {
1251 # OBD_FAIL_MDS_REINT_NET_REP
1252     RC=0
1253     do_facet mds lctl set_param fail_loc=0x119
1254     do_facet client "$@" || RC=$?
1255     do_facet mds lctl set_param fail_loc=0
1256     return $RC
1257 }
1258
1259 pause_bulk() {
1260 #define OBD_FAIL_OST_BRW_PAUSE_BULK      0x214
1261     RC=0
1262     do_facet ost1 lctl set_param fail_loc=0x214
1263     do_facet client "$1" || RC=$?
1264     do_facet client "sync"
1265     do_facet ost1 lctl set_param fail_loc=0
1266     return $RC
1267 }
1268
1269 drop_ldlm_cancel() {
1270 #define OBD_FAIL_LDLM_CANCEL             0x304
1271     RC=0
1272     do_facet client lctl set_param fail_loc=0x304
1273     do_facet client "$@" || RC=$?
1274     do_facet client lctl set_param fail_loc=0
1275     return $RC
1276 }
1277
1278 drop_bl_callback() {
1279 #define OBD_FAIL_LDLM_BL_CALLBACK        0x305
1280     RC=0
1281     do_facet client lctl set_param fail_loc=0x305
1282     do_facet client "$@" || RC=$?
1283     do_facet client lctl set_param fail_loc=0
1284     return $RC
1285 }
1286
1287 drop_ldlm_reply() {
1288 #define OBD_FAIL_LDLM_REPLY              0x30c
1289     RC=0
1290     do_facet mds lctl set_param fail_loc=0x30c
1291     do_facet client "$@" || RC=$?
1292     do_facet mds lctl set_param fail_loc=0
1293     return $RC
1294 }
1295
1296 clear_failloc() {
1297     facet=$1
1298     pause=$2
1299     sleep $pause
1300     echo "clearing fail_loc on $facet"
1301     do_facet $facet "lctl set_param fail_loc=0 2>/dev/null || true"
1302 }
1303
1304 set_nodes_failloc () {
1305     local nodes=$1
1306     local node
1307
1308     for node in $nodes ; do
1309         do_node $node lctl set_param fail_loc=$2
1310     done
1311 }
1312
1313 set_nodes_failloc () {
1314     local nodes=$1
1315     local node
1316
1317     for node in $nodes ; do
1318         do_node $node sysctl -w lustre.fail_loc=$2
1319     done
1320 }
1321
1322 cancel_lru_locks() {
1323     $LCTL mark "cancel_lru_locks $1 start"
1324     for d in `find $LPROC/ldlm/namespaces | egrep -i $1`; do
1325         [ -f $d/lru_size ] && echo clear > $d/lru_size
1326         [ -f $d/lock_unused_count ] && grep [1-9] $d/lock_unused_count /dev/null
1327     done
1328     $LCTL mark "cancel_lru_locks $1 stop"
1329 }
1330
1331 default_lru_size()
1332 {
1333         NR_CPU=$(grep -c "processor" /proc/cpuinfo)
1334         DEFAULT_LRU_SIZE=$((100 * NR_CPU))
1335         echo "$DEFAULT_LRU_SIZE"
1336 }
1337
1338 lru_resize_enable()
1339 {
1340         NS=$1
1341         test "x$NS" = "x" && NS="mdc"
1342         for F in $LPROC/ldlm/namespaces/*$NS*/lru_size; do
1343                 D=$(dirname $F)
1344                 log "Enable lru resize for $(basename $D)"
1345                 echo "0" > $F
1346         done
1347 }
1348
1349 lru_resize_disable()
1350 {
1351         NS=$1
1352         test "x$NS" = "x" && NS="mdc"
1353         for F in $LPROC/ldlm/namespaces/*$NS*/lru_size; do
1354                 D=$(dirname $F)
1355                 log "Disable lru resize for $(basename $D)"
1356                 DEFAULT_LRU_SIZE=$(default_lru_size)
1357                 echo "$DEFAULT_LRU_SIZE" > $F
1358         done
1359 }
1360
1361 pgcache_empty() {
1362     for a in /proc/fs/lustre/llite/*/dump_page_cache; do
1363         if [ `wc -l $a | awk '{print $1}'` -gt 1 ]; then
1364             echo there is still data in page cache $a ?
1365             cat $a;
1366             return 1;
1367         fi
1368     done
1369     return 0
1370 }
1371
1372 debugsave() {
1373     DEBUGSAVE="$(lctl get_param -n debug)"
1374 }
1375
1376 debugrestore() {
1377     [ -n "$DEBUGSAVE" ] && lctl set_param debug="${DEBUGSAVE}"
1378     DEBUGSAVE=""
1379 }
1380
1381 ##################################
1382 # Test interface
1383 ##################################
1384
1385 error_noexit() {
1386     local TYPE=${TYPE:-"FAIL"}
1387     local ERRLOG
1388     lctl set_param fail_loc=0 2>/dev/null || true
1389     log " ${TESTSUITE} ${TESTNAME}: @@@@@@ ${TYPE}: $@ "
1390     ERRLOG=$TMP/lustre_${TESTSUITE}_${TESTNAME}.$(date +%s)
1391     echo "Dumping lctl log to $ERRLOG"
1392     # We need to dump the logs on all nodes
1393     local NODES=$(nodes_list)
1394     for NODE in $NODES; do
1395         do_node $NODE $LCTL dk $ERRLOG
1396     done
1397     debugrestore
1398     [ "$TESTSUITELOG" ] && echo "$0: ${TYPE}: $TESTNAME $@" >> $TESTSUITELOG
1399 }
1400
1401 error() {
1402     error_noexit "$@"
1403     $FAIL_ON_ERROR && exit 1 || true
1404 }
1405
1406 error_exit() {
1407     error_noexit "$@"
1408     exit 1
1409 }
1410
1411 # use only if we are ignoring failures for this test, bugno required.
1412 # (like ALWAYS_EXCEPT, but run the test and ignore the results.)
1413 # e.g. error_ignore 5494 "your message"
1414 error_ignore() {
1415     TYPE="IGNORE (bz$1)"
1416     shift
1417     error_noexit "$@"
1418 }
1419
1420 skip () {
1421         log " SKIP: ${TESTSUITE} ${TESTNAME} $@"
1422         [ "$TESTSUITELOG" ] && echo "${TESTSUITE}: SKIP: $TESTNAME $@" >> $TESTSUITELOG
1423 }
1424
1425 build_test_filter() {
1426     [ "$ONLY" ] && log "only running test `echo $ONLY`"
1427     for O in $ONLY; do
1428         eval ONLY_${O}=true
1429     done
1430     [ "$EXCEPT$ALWAYS_EXCEPT" ] && \
1431         log "excepting tests: `echo $EXCEPT $ALWAYS_EXCEPT`"
1432     [ "$EXCEPT_SLOW" ] && \
1433         log "skipping tests SLOW=no: `echo $EXCEPT_SLOW`"
1434     for E in $EXCEPT $ALWAYS_EXCEPT; do
1435         eval EXCEPT_${E}=true
1436     done
1437     for E in $EXCEPT_SLOW; do
1438         eval EXCEPT_SLOW_${E}=true
1439     done
1440     for G in $GRANT_CHECK_LIST; do
1441         eval GCHECK_ONLY_${G}=true
1442         done
1443 }
1444
1445 _basetest() {
1446     echo $*
1447 }
1448
1449 basetest() {
1450     IFS=abcdefghijklmnopqrstuvwxyz _basetest $1
1451 }
1452
1453 run_test() {
1454     export base=`basetest $1`
1455     if [ ! -z "$ONLY" ]; then
1456         testname=ONLY_$1
1457         if [ ${!testname}x != x ]; then
1458             run_one $1 "$2"
1459             return $?
1460         fi
1461         testname=ONLY_$base
1462         if [ ${!testname}x != x ]; then
1463             run_one $1 "$2"
1464             return $?
1465         fi
1466         echo -n "."
1467         return 0
1468     fi
1469     testname=EXCEPT_$1
1470     if [ ${!testname}x != x ]; then
1471         TESTNAME=test_$1 skip "skipping excluded test $1"
1472         return 0
1473     fi
1474     testname=EXCEPT_$base
1475     if [ ${!testname}x != x ]; then
1476         TESTNAME=test_$1 skip "skipping excluded test $1 (base $base)"
1477         return 0
1478     fi
1479     testname=EXCEPT_SLOW_$1
1480     if [ ${!testname}x != x ]; then
1481         TESTNAME=test_$1 skip "skipping SLOW test $1"
1482         return 0
1483     fi
1484     testname=EXCEPT_SLOW_$base
1485     if [ ${!testname}x != x ]; then
1486         TESTNAME=test_$1 skip "skipping SLOW test $1 (base $base)"
1487         return 0
1488     fi
1489
1490     run_one $1 "$2"
1491
1492     return $?
1493 }
1494
1495 EQUALS="======================================================================"
1496 equals_msg() {
1497     msg="$@"
1498
1499     local suffixlen=$((${#EQUALS} - ${#msg}))
1500     [ $suffixlen -lt 5 ] && suffixlen=5
1501     log `echo $(printf '===== %s %.*s\n' "$msg" $suffixlen $EQUALS)`
1502 }
1503
1504 log() {
1505     echo "$*"
1506     lsmod | grep lnet > /dev/null || load_modules
1507
1508     local MSG="$*"
1509     # Get rif of '
1510     MSG=${MSG//\'/\\\'}
1511     MSG=${MSG//\(/\\\(}
1512     MSG=${MSG//\)/\\\)}
1513     MSG=${MSG//\;/\\\;}
1514     MSG=${MSG//\|/\\\|}
1515     MSG=${MSG//\>/\\\>}
1516     MSG=${MSG//\</\\\<}
1517     local NODES=$(nodes_list)
1518     for NODE in $NODES; do
1519         do_node $NODE $LCTL mark "$MSG" 2> /dev/null || true
1520     done
1521 }
1522
1523 trace() {
1524         log "STARTING: $*"
1525         strace -o $TMP/$1.strace -ttt $*
1526         RC=$?
1527         log "FINISHED: $*: rc $RC"
1528         return 1
1529 }
1530
1531 pass() {
1532     echo PASS $@
1533 }
1534
1535 check_mds() {
1536     FFREE=`cat /proc/fs/lustre/osd/*MDT*/filesfree`
1537     FTOTAL=`cat /proc/fs/lustre/osd/*MDT*/filestotal`
1538     [ $FFREE -ge $FTOTAL ] && error "files free $FFREE > total $FTOTAL" || true
1539 }
1540
1541 reset_fail_loc () {
1542     local myNODES=$(nodes_list)
1543     local NODE
1544
1545     for NODE in $myNODES; do
1546         do_node $NODE "lctl set_param fail_loc=0 2>/dev/null || true"
1547     done
1548 }
1549
1550 run_one() {
1551     testnum=$1
1552     message=$2
1553     tfile=f${testnum}
1554     export tdir=d0.${TESTSUITE}/d${base}
1555     local SAVE_UMASK=`umask`
1556     umask 0022
1557     mkdir -p $DIR/$tdir
1558
1559     BEFORE=`date +%s`
1560     log "== test $testnum: $message ============ `date +%H:%M:%S` ($BEFORE)"
1561     #check_mds
1562     export TESTNAME=test_$testnum
1563     test_${testnum} || error "test_$testnum failed with $?"
1564     #check_mds
1565     cd $SAVE_PWD
1566     reset_fail_loc
1567     check_grant ${testnum} || error "check_grant $testnum failed with $?"
1568     [ -f $CATASTROPHE ] && [ `cat $CATASTROPHE` -ne 0 ] && \
1569         error "LBUG/LASSERT detected"
1570     ps auxww | grep -v grep | grep -q multiop && error "multiop still running"
1571     pass "($((`date +%s` - $BEFORE))s)"
1572     rmdir ${DIR}/$tdir >/dev/null 2>&1 || true
1573     unset TESTNAME
1574     unset tdir
1575     umask $SAVE_UMASK
1576     $CLEANUP
1577 }
1578
1579 canonical_path() {
1580     (cd `dirname $1`; echo $PWD/`basename $1`)
1581 }
1582
1583 sync_clients() {
1584     [ -d $DIR1 ] && cd $DIR1 && sync; sleep 1; sync
1585     [ -d $DIR2 ] && cd $DIR2 && sync; sleep 1; sync
1586         cd $SAVE_PWD
1587 }
1588
1589 check_grant() {
1590     export base=`basetest $1`
1591     [ "$CHECK_GRANT" == "no" ] && return 0
1592
1593         testname=GCHECK_ONLY_${base}
1594         [ ${!testname}x == x ] && return 0
1595
1596         echo -n "checking grant......"
1597         cd $SAVE_PWD
1598         # write some data to sync client lost_grant
1599         rm -f $DIR1/${tfile}_check_grant_* 2>&1
1600         for i in `seq $OSTCOUNT`; do
1601                 $LFS setstripe $DIR1/${tfile}_check_grant_$i -i $(($i -1)) -c 1
1602                 dd if=/dev/zero of=$DIR1/${tfile}_check_grant_$i bs=4k \
1603                                               count=1 > /dev/null 2>&1
1604         done
1605         # sync all the data and make sure no pending data on server
1606         sync_clients
1607         
1608         #get client grant and server grant
1609         client_grant=0
1610     for d in ${LPROC}/osc/*/cur_grant_bytes; do
1611                 client_grant=$((client_grant + `cat $d`))
1612         done
1613         server_grant=0
1614         for d in ${LPROC}/obdfilter/*/tot_granted; do
1615                 server_grant=$((server_grant + `cat $d`))
1616         done
1617
1618         # cleanup the check_grant file
1619         for i in `seq $OSTCOUNT`; do
1620                 rm $DIR1/${tfile}_check_grant_$i
1621         done
1622
1623         #check whether client grant == server grant
1624         if [ $client_grant != $server_grant ]; then
1625                 echo "failed: client:${client_grant} server: ${server_grant}"
1626                 return 1
1627         else
1628                 echo "pass"
1629         fi
1630 }
1631
1632 ########################
1633 # helper functions
1634
1635 osc_to_ost()
1636 {
1637     osc=$1
1638     ost=`echo $1 | awk -F_ '{print $3}'`
1639     if [ -z $ost ]; then
1640         ost=`echo $1 | sed 's/-osc.*//'`
1641     fi
1642     echo $ost
1643 }
1644
1645 remote_mds ()
1646 {
1647     [ -z "$(lctl dl | grep mdt)" ]
1648 }
1649
1650 remote_mds_nodsh()
1651 {
1652     remote_mds && [ "$PDSH" = "no_dsh" -o -z "$PDSH" -o -z "$mds_HOST" ]
1653 }
1654
1655 remote_ost ()
1656 {
1657     [ -z "$(lctl dl | grep ost)" ]
1658 }
1659
1660 remote_ost_nodsh()
1661 {
1662     remote_ost && [ "$PDSH" = "no_dsh" -o -z "$PDSH" -o -z "$ost_HOST" ]
1663 }
1664
1665 mdts_nodes () {
1666     local MDSNODES=$(facet_host $SINGLEMDS)
1667     local NODES_sort
1668
1669     # FIXME: Currenly we use only $SINGLEMDS,
1670     # should be fixed when we will start to test cmd.
1671     echo $MDSNODES
1672     return
1673
1674     for num in `seq $MDSCOUNT`; do
1675         local myMDS=$(facet_host mds$num)
1676         MDSNODES="$MDSNODES $myMDS"
1677     done
1678     NODES_sort=$(for i in $MDSNODES; do echo $i; done | sort -u)
1679
1680     echo $NODES_sort
1681 }
1682
1683 osts_nodes () {
1684     local OSTNODES=$(facet_host ost1)
1685     local NODES_sort
1686
1687     for num in `seq $OSTCOUNT`; do
1688         local myOST=$(facet_host ost$num)
1689         OSTNODES="$OSTNODES $myOST"
1690     done
1691     NODES_sort=$(for i in $OSTNODES; do echo $i; done | sort -u)
1692
1693     echo $NODES_sort
1694 }
1695
1696 nodes_list () {
1697     # FIXME. We need a list of clients
1698     local myNODES=$HOSTNAME
1699     local myNODES_sort
1700
1701     # CLIENTS (if specified) contains the local client
1702     [ -n "$CLIENTS" ] && myNODES=${CLIENTS//,/ }
1703
1704     if [ "$PDSH" -a "$PDSH" != "no_dsh" ]; then
1705         myNODES="$myNODES $(osts_nodes) $(mdts_nodes)"
1706     fi
1707
1708     myNODES_sort=$(for i in $myNODES; do echo $i; done | sort -u)
1709
1710     echo $myNODES_sort
1711 }
1712
1713 is_patchless ()
1714 {
1715     lctl get_param version | grep -q patchless
1716 }
1717
1718 get_node_count() {
1719    local nodes="$@"
1720    echo $nodes | wc -w || true
1721 }
1722
1723 mixed_ost_devs () {
1724     local nodes=$(osts_nodes)
1725     local osscount=$(get_node_count "$nodes")
1726     [ ! "$OSTCOUNT" = "$osscount" ]
1727 }
1728
1729 check_runas_id_ret() {
1730     local myRC=0
1731     local myRUNAS_ID=$1
1732     shift
1733     local myRUNAS=$@
1734     if [ -z "$myRUNAS" ]; then
1735         error_exit "myRUNAS command must be specified for check_runas_id"
1736     fi
1737     if $GSS_KRB5; then
1738         $myRUNAS krb5_login.sh || \
1739             error "Failed to refresh Kerberos V5 TGT for UID $myRUNAS_ID."
1740     fi
1741     mkdir $DIR/d0_runas_test
1742     chmod 0755 $DIR
1743     chown $myRUNAS_ID:$myRUNAS_ID $DIR/d0_runas_test
1744     $myRUNAS touch $DIR/d0_runas_test/f$$ || myRC=$?
1745     rm -rf $DIR/d0_runas_test
1746     return $myRC
1747 }
1748
1749 check_runas_id() {
1750     local myRUNAS_ID=$1
1751     shift
1752     local myRUNAS=$@
1753     check_runas_id_ret $myRUNAS_ID $myRUNAS || \
1754         error "unable to write to $DIR/d0_runas_test as UID $myRUNAS_ID. 
1755         Please set RUNAS_ID to some UID which exists on MDS and client or 
1756         add user $myRUNAS_ID:$myRUNAS_ID on these nodes."
1757 }
1758
1759 # Run multiop in the background, but wait for it to print
1760 # "PAUSING" to its stdout before returning from this function.
1761 multiop_bg_pause() {
1762     MULTIOP_PROG=${MULTIOP_PROG:-multiop}
1763     FILE=$1
1764     ARGS=$2
1765
1766     TMPPIPE=/tmp/multiop_open_wait_pipe.$$
1767     mkfifo $TMPPIPE
1768
1769     echo "$MULTIOP_PROG $FILE v$ARGS"
1770     $MULTIOP_PROG $FILE v$ARGS > $TMPPIPE &
1771
1772     echo "TMPPIPE=${TMPPIPE}"
1773     read -t 60 multiop_output < $TMPPIPE
1774     if [ $? -ne 0 ]; then
1775         rm -f $TMPPIPE
1776         return 1
1777     fi
1778     rm -f $TMPPIPE
1779     if [ "$multiop_output" != "PAUSING" ]; then
1780         echo "Incorrect multiop output: $multiop_output"
1781         kill -9 $PID
1782         return 1
1783     fi
1784
1785     return 0
1786 }
1787
1788 # reset llite stat counters
1789 clear_llite_stats(){
1790         lctl set_param -n llite.*.stats 0
1791 }
1792
1793 # sum llite stat items
1794 calc_llite_stats() {
1795         local res=$(lctl get_param -n llite.*.stats |
1796                     awk 'BEGIN {s = 0} END {print s} /^'"$1"'/ {s += $2}')
1797         echo $res
1798 }
1799
1800 # save_lustre_params(node, parameter_mask)
1801 # generate a stream of formatted strings (<node> <param name>=<param value>)
1802 save_lustre_params() {
1803         local s
1804         do_node $1 "lctl get_param $2" | while read s; do echo "$1 $s"; done
1805 }
1806
1807 # restore lustre parameters from input stream, produces by save_lustre_params
1808 restore_lustre_params() {
1809         local node
1810         local name
1811         local val
1812         while IFS=" =" read node name val; do
1813                 do_node $node "lctl set_param -n $name $val"
1814         done
1815 }
1816